// adc.c
#include "adc.h"
#include <pic18fx490.h>
#include "lcd.h"

//unsigned char progress; 
//unsigned char j_left;
//unsigned char j_right;
//unsigned char j_up;
//unsigned char j_down;

void InitADC(void) {

	// Disable ADC
	ADCON0 = 0x0;	

	// Only AN0, AN1 as analog input, AVSS and AVDD as referances
	ADCON1 = 0x0D;

	// Fadc = Fosc/64, 20 TAD
	ADCON2 = 0x3E;

	// Input
	TRISA = 0xFF;

	// not interrupt driven 
	ADIE=0;		

	// Comparator OFF
	// CMCON = 0x7;

	// progress
	// progress = 1;

	//joystick
	// j_left 	= 1;
	// j_right 	= 1;
	// j_up		= 1;
	// j_down	= 1;
}

unsigned int GetValueAN0(void) {

	unsigned int val = 0;

	// Select Chanel0, enable ADC
	ADCON0 = 0x01;

	// wait for end of conversion
	// while(ADCON0&0x2);
	GODONE=1;
	while(GODONE)continue;

	// get value
	val = ADRES;

	// clear bit
	ADIF=0;

	// Disable ADC
	ADCON0 = 0x0;

	return val;

}

unsigned int GetValueAN1(void) {

	unsigned int val = 0;

	// Select Chanel0, enable ADC
	ADCON0 = 0x05;

	// wait for end of conversion
	// while(ADCON0&0x2);
	GODONE=1;
	while(GODONE)continue;

	// get value
	val = ADRES;

	// clear bit
	ADIF=0;

	// Disable ADC
	ADCON0 = 0x0;

	return val;
}

void PreCalcProgres(void) {
/*	
	if(progress>10) progress = 10;
	if(progress<1) 	progress = 1;

	progres_off;
	progress_start;
	progress_end;

	switch(progress) {
		case 1: progress_1; break;
		case 2: progress_2; break;
		case 3: progress_3; break;
		case 4: progress_4; break;
		case 5: progress_5; break;
		case 6: progress_6; break;
		case 7: progress_7; break;
		case 8: progress_8; break;
		case 9: progress_9; break;
		case 10: progress_10; break;
	}
*/
}

void CalcTemp(unsigned int tmp) {

	// very approximate
	unsigned int real_tmp = tmp/13;

    char edi = (real_tmp%10);
    char des = (real_tmp%100 - edi)/10;
    char sto = (real_tmp%1000 - des)/100;
    char hil = (real_tmp%10000 - sto)/1000;

	all_1_off;
	FormatChar_1(' ');
	all_2_off;
	FormatChar_2(' ');	
	all_3_off;
	FormatChar_3(hil+48);
	all_4_off;
	FormatChar_4(sto+48);
	all_5_off;
	FormatChar_5(des+48);
	all_6_off;
	FormatChar_6(edi+48);
	all_7_off;
	FormatChar_7('C');	

	DOT3;

}

void CalcArr(unsigned int adc) {
/*
	// right
	if(((adc&0xF000) == 0x2000)&&(j_right==1)) {
		arr_r;
		progress++;
		PreCalcProgres();	
		
		j_left 	= 1;
		j_right = 0;
		j_up	= 1;
		j_down	= 1;
		
	}
	// left
	if(((adc&0xF000) == 0x7000)&&(j_left==1)) {
		arr_l;
		progress--;
		PreCalcProgres();

		j_left 	= 0;
		j_right = 1;
		j_up	= 1;
		j_down	= 1;
	}
	// up
	if(((adc&0xF000) == 0x4000)&&(j_up==1)) {
		arr_u;

		j_left 	= 1;
		j_right = 1;
		j_up	= 0;
		j_down	= 1;
	}
	// down
	if(((adc&0xFF00) == 0x0F00)&&(j_down==1)) {
		arr_d;

		j_left 	= 1;
		j_right = 1;
		j_up	= 1;
		j_down	= 0;
	}
	// nothing
	if((adc&0xF000) == 0x0000) {
		arr_off;

		j_left 	= 1;
		j_right = 1;
		j_up	= 1;
		j_down	= 1;
	}
*/
}
